Public Class frmBacteriaMaint


    Private TheBacteria As Bacteria
    Private fMode As GenDec.FormMode



#Region " Form Events "

    Private Sub frmOligoMaint_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'UFS.FormLoad(Me, GenDec.INIFileName)

        If frmNewMain.BacteriaCustomField1 = "" Then
            Me.lblCustomField1.Text = "[Custom 1]:"
        Else
            Me.lblCustomField1.Text = frmNewMain.BacteriaCustomField1 & ":"
        End If

        If frmNewMain.BacteriaCustomField2 = "" Then
            Me.lblCustomField2.Text = "[Custom 2]:"
        Else
            Me.lblCustomField2.Text = frmNewMain.BacteriaCustomField2 & ":"
        End If



        If TheBacteria.BacteriaID = 0 Then
            'New
            Me.Text = "New Bacteria"
            fMode = GenDec.FormMode.ModeAdd

            TheBacteria.LabName = frmNewMain.BacteriaLabSuffix


            Me.txtSuffix.Text = Bacteria.DBNextBacteriaID(frmNewMain.Conn)



        Else
            'Edit
            Me.Text = "Edit Bacteria"
            fMode = GenDec.FormMode.ModeEdit
            Me.txtSuffix.Text = TheBacteria.BacteriaID

        End If

        Me.dtpRecDate.Focus()


        Me.FormLoad()


    End Sub

    Private Sub frmOligoMaint_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'UFS.FormSave(Me, GenDec.INIFileName)

    End Sub

#End Region


#Region " Form Support "

    Private Sub FormLoad()

        With Me.TheBacteria

            Me.txtLabName.Text = .LabName
            Me.dtpRecDate.Value = .RecDate
            Me.txtFormerName.Text = .FormerName
            Me.txtHostStrain.Text = .HostStrain
            Me.txtMarkers.Text = .Markers
            Me.txtPlasmidSize.Text = .PlasmidSize
            Me.txtParentVector.Text = .ParentVector
            Me.txtInsert.Text = .InsertOf
            Me.txtDonor.Text = .Donor
            Me.txtComments.Text = .Comments
            Me.txtCustomField1.Text = .CustomField1
            Me.txtCustomField2.Text = .CustomField2

        End With


    End Sub

    Private Sub FormSave()

        With Me.TheBacteria
            .LabName = Me.txtLabName.Text
            .RecDate = Me.dtpRecDate.Value
            .FormerName = Me.txtFormerName.Text
            .HostStrain = Me.txtHostStrain.Text
            .Markers = Me.txtMarkers.Text
            .PlasmidSize = Me.txtPlasmidSize.Text
            .ParentVector = Me.txtParentVector.Text
            .InsertOf = Me.txtInsert.Text
            .Donor = Me.txtDonor.Text
            .Comments = Me.txtComments.Text
            .CustomField1 = Me.txtCustomField1.Text
            .CustomField2 = Me.txtCustomField2.Text
        End With


    End Sub


#End Region



    Private Function ValidateForm() As Boolean

        'Const cInvalidData As String = "Invalid Data"



        If Me.txtLabName.Text = "" Then
            MessageBox.Show("Specify Lab Name", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtLabName.Focus()
            Exit Function
        End If

        If Me.txtFormerName.Text = "" Then
            MessageBox.Show("Specify Former Name", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtLabName.Focus()
            Exit Function
        End If


        'Made it this far
        Return True

    End Function


    Public Function paDialog(ByRef rBacteria As Bacteria) As Windows.Forms.DialogResult


        Me.TheBacteria = rBacteria

        Me.ShowDialog()

        Return Me.DialogResult


    End Function


#Region " Control Support "

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click

        If ValidateForm() = False Then Exit Sub

        Me.FormSave()

        'Saving to the database
        'TheOligo.DBSave(frmMain.Conn)


        Me.DialogResult = Windows.Forms.DialogResult.OK

        Me.Close()


    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.Close()

    End Sub


#End Region




End Class