Public Class frmCellLineList

    Public fCellLineCollect As Collection
    Private fMode As GenDec.FormMode


    Private fcLastColSorted As Integer = -1


#Region " Form Events "


    Private Sub frmList_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        UFS.FormLoad(Me, GenDec.INIFileName, , 1)

        'FormSaber.FL(Me)

        Me.FormLoad()



    End Sub

    Private Sub frmList_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        UFS.FormSave(Me, GenDec.INIFileName, , 1)

        'FormSaber.FS(Me)

    End Sub

    Private Sub frmList_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        'Me.lvwList.Width = Me.Width - Me.lvwList.Left - Me.lvwList.Left
        'Me.lvwList.Height = Me.Height - 100


    End Sub


#End Region


#Region " List View Support "


    Private Sub LVWLoadItem(ByRef rCellLine As CellLine, Optional ByVal vIndex As Integer = -1, Optional ByVal vSelect As Byte = 0, Optional ByVal vRemItem As Byte = 0)

        Dim tItem As New ListViewItem

        tItem.Tag = rCellLine


        tItem.SubItems(0).Text = rCellLine.FullName
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, String.Format(GenDec.cFormatDate, rCellLine.RecDate)))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.FormerName))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.Donor))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.CellLineName))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.Species))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.TissueType))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.Modification))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.PassageNumber))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.StorageLocation))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.NumberOfVials))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rCellLine.Comments))


        GenDec.LVWItemPlace(Me.lvwList, tItem, vIndex, vSelect, vRemItem)

    End Sub


    Private Sub lvwList_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvwList.ColumnClick

        Dim lvwColumnSorter As New LVWColSorter(Me.lvwList, e.Column)


        ' Set the column number that is to be sorted; default to ascending.
        If Me.lvwList.Sorting = SortOrder.Ascending Then
            'Was Ascending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Descending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Descending

        Else
            'Was Descending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Ascending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Ascending

        End If

        Me.lvwList.ListViewItemSorter = lvwColumnSorter


        If Me.lvwList.SelectedItems.Count > 0 Then
            Call Me.lvwList.SelectedItems(0).EnsureVisible()
        End If


    End Sub

    Private Sub lvwList_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvwList.MouseDoubleClick

        Call mnuEdit_Click(Nothing, Nothing)

    End Sub


#End Region



    Public Sub paDialog(ByRef rCollect As Collection, ByVal vMode As GenDec.FormMode)

        Me.fCellLineCollect = rCollect
        Me.fMode = vMode


        Me.Show()


    End Sub


#Region "Context Menu Support "


    Private Sub mnuEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionEdit.Click

        Me.mnuTSEdit_Click(Nothing, Nothing)

    End Sub


    Private Sub mnuPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionPrint.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim PrintStr As String = ""

        Dim tCellLine As CellLine = CType(Me.lvwList.SelectedItems(0).Tag, CellLine)

        With tCellLine

            PrintStr = PrintStr & "Lab Name: " & .FullName & vbCrLf
            PrintStr = PrintStr & "Rec Date: " & .RecDate & vbCrLf
            PrintStr = PrintStr & "Cell Line Name: " & .CellLineName & vbCrLf
            PrintStr = PrintStr & "Former Name: " & .FormerName & vbCrLf
            PrintStr = PrintStr & "Species: " & .Species & vbCrLf

            PrintStr = PrintStr & "Tissue Type: " & .TissueType & vbCrLf
            PrintStr = PrintStr & "Donor: " & .Donor & vbCrLf
            PrintStr = PrintStr & "Modification: " & .Modification & vbCrLf

            PrintStr = PrintStr & "Passage Number: " & .PassageNumber & vbCrLf
            PrintStr = PrintStr & "Number Of Vials: " & .NumberOfVials & vbCrLf
            PrintStr = PrintStr & "Source: " & .Source & vbCrLf

            PrintStr = PrintStr & "Storage Location: " & .StorageLocation & vbCrLf
            PrintStr = PrintStr & "Preferred: " & .PreferredMedium & vbCrLf


            PrintStr = PrintStr & "Comments: " & vbCrLf & .Comments & vbCrLf


            If .CustomField1 <> "" Then
                PrintStr = PrintStr & frmNewMain.YeastCustomField1 & ":" & .CustomField1 & vbCrLf
            End If

            If .CustomField2 <> "" Then
                PrintStr = PrintStr & frmNewMain.YeastCustomField2 & ":" & .CustomField2 & vbCrLf
            End If



        End With

        'dim Blah as Ne
        Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        Blah.Write(PrintStr)


        Blah.Close()

        Process.Start(Application.StartupPath & "\Print.txt")


    End Sub





    Private Sub mnuActionFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionFind.Click

        Dim Blah As New frmLVWFind

        Blah.paShow(Me, Me.lvwList)


    End Sub


    Private Sub mnuActionAdd_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionAdd.Click

        Me.mnuTSAdd_Click(Nothing, Nothing)


    End Sub

    Private Sub mnuActionDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionDelete.Click

        Dim tCellLine As CellLine

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub

        tCellLine = CType(Me.lvwList.SelectedItems(0).Tag, CellLine)

        If MessageBox.Show("Are you sure you want do delete " & tCellLine.CellLineName & "?", My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
            CellLine.DBDelete(frmNewMain.Conn, tCellLine.CellLineID)
            Me.lvwList.SelectedItems(0).Remove()
        End If

    End Sub


#End Region


#Region " Main Menu Strip Support "


    Private Sub mnuTSFullList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSFullList.Click

        Me.fMode = GenDec.FormMode.ModeA

        Me.FormLoad()


    End Sub

    Private Sub mnuTSSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSSearch.Click

        Dim Blah As New frmSearch
        Dim CL As New CellLine


        If Blah.paDialog(CL, Me.fCellLineCollect) = Windows.Forms.DialogResult.OK Then


            Me.fMode = GenDec.FormMode.ModeB

            Me.FormLoad()

        End If



    End Sub


    Private Sub mnuTSAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSAdd.Click


        Dim Blah As New frmCellLineMaint

        Dim tCellLine As New CellLine

        If Blah.paDialog(tCellLine) = Windows.Forms.DialogResult.OK Then
            'They Clicked Ok

            Me.fMode = GenDec.FormMode.ModeA
            Me.FormLoad()

            tCellLine.DBSave(frmNewMain.Conn)

            Me.LVWLoadItem(tCellLine, , 1)

        End If

    End Sub

    Private Sub mnuTSEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSEdit.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim Blah As New frmCellLineMaint
        Dim tCellLine As CellLine = CType(Me.lvwList.SelectedItems(0).Tag, CellLine)

        If Blah.paDialog(tCellLine) = Windows.Forms.DialogResult.OK Then
            tCellLine.DBSave(frmNewMain.Conn)
            'Updating the list

            Me.LVWLoadItem(tCellLine, Me.lvwList.SelectedItems(0).Index, 1, 1)

        End If

    End Sub


    Private Sub mnuTSPrintList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSPrintList.Click

        'Const cPadID As Integer = 5
        'Const cPadLabName As Integer = 10
        ''Const cPadPurpose As Integer = 30
        'Const cPadCellLineName As Integer = 40
        'Const cPadDonor As Integer = 15
        'Const cPadStorage As Integer = 15


        ''labname, cell line, donor, storage location

        'Dim tStr As String = "Lab Name".PadRight(cPadLabName) & "Cell Line Name".PadRight(cPadCellLineName) & "Donor".PadRight(cPadDonor) & "Storage".PadRight(cpadstorage)
        'Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        'For Each tCellLine As CellLine In Me.fCellLineCollect
        '    tStr = tStr & vbCrLf & tCellLine.FullName.PadRight(cPadLabName) & tCellLine.CellLineName.PadRight(cPadCellLineName) & tCellLine.Donor.PadRight(cPadDonor) & tCellLine.StorageLocation.PadRight(cPadStorage)
        'Next


        'Blah.Write(tStr)

        'Blah.Close()


        'Process.Start(Application.StartupPath & "\Print.txt")



        Dim tStr As String = ""
        Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        For Each tCellLine As CellLine In Me.fCellLineCollect

            With tCellLine
                tStr = tStr & .FullName & vbCrLf & String.Format(GenDec.cFormatDate, .RecDate) & vbCrLf & .FormerName & vbCrLf & .Donor & vbCrLf & vbCrLf
            End With


        Next


        Blah.Write(tStr)
        Blah.Close()

        Process.Start(Application.StartupPath & "\Print.txt")



    End Sub



#End Region



    Private Sub btnDone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Me.Close()

    End Sub


    Private Sub FullList()

        Me.lvwList.Items.Clear()
        Me.Text = "Full List"

        For Each tCellLine As CellLine In CellLine.DBCellLines(frmNewMain.Conn)
            fCellLineCollect.Add(tCellLine)
        Next


    End Sub


#Region " Form Support "


    Private Sub FormLoad()

        Me.lvwList.Items.Clear()


        Select Case fMode

            Case GenDec.FormMode.ModeA



                fCellLineCollect.Clear()

                For Each tCellLine As CellLine In CellLine.DBCellLines(frmNewMain.Conn)
                    fCellLineCollect.Add(tCellLine)
                Next


                Me.Text = "Cell Line Complete List (" & fCellLineCollect.Count & " Rows" & ")"


            Case GenDec.FormMode.ModeB
                Me.Text = "Cell LIne Search Results (" & fCellLineCollect.Count & " Rows" & ")"

            Case Else
                Throw New Exception("No Mode for form")

        End Select


        For Each tCellLine As CellLine In fCellLineCollect
            Me.LVWLoadItem(tCellLine)
        Next





        'Me.Text = "Search Results (" & fYeastCollect.Count & " Rows" & ")"

    End Sub



#End Region



End Class