Public Class frmOligoMaint



    Private TheOligo As Oligo
    Private fMode As GenDec.FormMode


#Region " Form Events "

    Private Sub frmOligoMaint_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'UFS.FormLoad(Me, GenDec.INIFileName)


        If frmNewMain.OligoCustomField1 = "" Then
            Me.lblCustomField1.Text = "[Custom 1]:"
        Else
            Me.lblCustomField1.Text = frmNewMain.OligoCustomField1 & ":"
        End If

        If frmNewMain.OligoCustomField2 = "" Then
            Me.lblCustomField2.Text = "[Custom 2]:"
        Else
            Me.lblCustomField2.Text = frmNewMain.OligoCustomField2 & ":"
        End If



        If TheOligo.OligoID = 0 Then
            'New
            Me.Text = "New Oligo"
            fMode = GenDec.FormMode.ModeAdd

            TheOligo.LabName = frmNewMain.OligoLabSuffix

            'TheOligo.OligoID = Oligo.DBNextOligoID(frmMain.Conn)
            Me.txtSuffix.Text = Oligo.DBNextOligoID(frmNewMain.Conn)



        Else
            'Edit
            Me.Text = "Edit Oligo"
            fMode = GenDec.FormMode.ModeEdit
            Me.txtSuffix.Text = TheOligo.OligoID

        End If

        Me.dtpRecDate.Focus()


        Me.FormLoad()


    End Sub

    Private Sub frmOligoMaint_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'UFS.FormSave(Me, GenDec.INIFileName)

    End Sub

#End Region


#Region " Form Support "

    Private Sub FormLoad()

        With Me.TheOligo

            Me.txtLabName.Text = .LabName
            Me.dtpRecDate.Value = .RecDate
            Me.txtFormerName.Text = .FormerName
            Me.txtPurpose.Text = .Purpose
            Me.txtSequence.Text = .Sequnce
            Me.txtRestrictionSites.Text = .RestrictionSite
            Me.txtGene.Text = .Gene
            Me.txtSpecies.Text = .Speices
            Me.txtPositionOf.Text = .Position
            Me.txtStrand.Text = .Strand
            Me.txtDonor.Text = .Donor
            Me.txtStockConc.Text = .StockConc
            Me.txtSupplier.Text = .Supplier
            Me.txtComments.Text = .Comments
            Me.txtCustomField1.Text = .CustomField1
            Me.txtCustomField2.Text = .CustomField2
        End With


    End Sub

    Private Sub FormSave()

        With Me.TheOligo
            .LabName = Me.txtLabName.Text
            .RecDate = Me.dtpRecDate.Value
            .FormerName = Me.txtFormerName.Text
            .Purpose = Me.txtPurpose.Text
            .Sequnce = Me.txtSequence.Text
            .RestrictionSite = Me.txtRestrictionSites.Text
            .Gene = Me.txtGene.Text
            .Speices = Me.txtSpecies.Text
            .Position = Me.txtPositionOf.Text
            .Strand = Me.txtStrand.Text
            .Donor = Me.txtDonor.Text
            .StockConc = Me.txtStockConc.Text
            .Supplier = Me.txtSupplier.Text
            .Comments = Me.txtComments.Text
            .CustomField1 = Me.txtCustomField1.Text
            .CustomField2 = Me.txtCustomField2.Text

            'updating the tm
            '.Tm = DNA.BasicTm(.Sequnce)
            .Tm = DNA.GoodTm(.Sequnce, frmNewMain.OligoMOfNaCl, frmNewMain.OligoPerFormamide)


        End With


    End Sub


#End Region



    Private Function ValidateForm() As Boolean

        'Const cInvalidData As String = "Invalid Data"

        If Me.txtSequence.Text = "" Then
            'ahmed requested this fix. I had messed up before
            MessageBox.Show("Specify a sequence", "Invalid Oligo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtSequence.Focus()
            Exit Function
        End If

        'fixing the dna to remove spaces etc.
        Me.txtSequence.Text = DNA.DNAFix(Me.txtSequence.Text)


        If Me.txtLabName.Text = "" Then
            MessageBox.Show("Specify Lab Name.", "Invalid Oligo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtLabName.Focus()
            Exit Function
        End If

        If Me.txtFormerName.Text = "" Then
            MessageBox.Show("Specify Former Name.", "Invalid Oligo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtLabName.Focus()
            Exit Function
        End If


        If Me.txtFormerName.Text = "" Then

        End If


        'Checking the dna sequence
        If DNA.DNAIsValid(Me.txtSequence.Text) = False Then
            MessageBox.Show("Invalid DNA Sequence", "Invalid Oligo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtSequence.Focus()
            Exit Function
        End If


        'Made it this far
        Return True

    End Function


    Public Function paDialog(ByRef rOlg As Oligo) As Windows.Forms.DialogResult


        Me.TheOligo = rOlg

        Me.ShowDialog()

        Return Me.DialogResult


    End Function


#Region " Control Support "

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click

        If ValidateForm() = False Then Exit Sub

        Me.FormSave()

        'Saving to the database
        'TheOligo.DBSave(frmMain.Conn)


        Me.DialogResult = Windows.Forms.DialogResult.OK

        Me.Close()


    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.Close()

    End Sub


#End Region




    Private Sub txtSequence_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSequence.TextChanged

        Me.lblSequenceLength.Text = Me.txtSequence.Text.Length

    End Sub
End Class
