''' <summary>
''' A form used to set the settings for the lina software.
''' </summary>
''' <remarks></remarks>
Public Class frmSettings



    'Errors Abe Found
    'Todo: fix the find for the listview to remove unlabeled columns


    'stores the orignal database path so it is possible to determine if they did/didnot switch databases
    Private fOrigPath As String


#Region " Form Events "

    Private Sub frmSettings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        'Loading up the form.
        Me.txtDBPath.Text = frmNewMain.DBPath
        Me.fOrigPath = Me.txtDBPath.Text 'saving the original path incase they change it to a different one.

        Me.chkOligoEnabled.Checked = frmNewMain.OligoEnabled
        Me.txtOligoLabSuffix.Text = frmNewMain.OligoLabSuffix
        Me.txtOligoCustomField1.Text = frmNewMain.OligoCustomField1
        Me.txtOligoCustomField2.Text = frmNewMain.OligoCustomField2

        Me.txtMofNaCl.Text = frmNewMain.OligoMOfNaCl
        Me.txtPerFormamide.Text = frmNewMain.OligoPerFormamide


        Me.chkYeastEnabled.Checked = frmNewMain.YeastEnabled
        Me.txtYeastLabSuffix.Text = frmNewMain.YeastLabSuffix
        Me.txtYeastCustomField1.Text = frmNewMain.YeastCustomField1
        Me.txtYeastCustomField2.Text = frmNewMain.YeastCustomField2

        Me.chkBacteriaEnabled.Checked = frmNewMain.BacteriaEnabled
        Me.txtBacteriaLabSuffix.Text = frmNewMain.BacteriaLabSuffix
        Me.txtBacteriaCustomField1.Text = frmNewMain.BacteriaCustomField1
        Me.txtBacteriaCustomField2.Text = frmNewMain.BacteriaCustomField2


        Me.chkCellLineEnabled.Checked = frmNewMain.CellLineEnabled
        Me.txtCellLineLabSuffix.Text = frmNewMain.CellLineLabSuffix
        Me.txtCellLineCustomField1.Text = frmNewMain.CellLineCustomField1
        Me.txtCellLineCustomField2.Text = frmNewMain.CellLineCustomField2





    End Sub


    Private Sub frmSettings_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'all the heavy lifting is done on OK_Click

    End Sub


#End Region


#Region " Control Support "

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click

        'Validating the user's data
        If Me.ValidateForm = False Then Exit Sub


        'saving all the settings to the shared variables for later use
        frmNewMain.DBPath = Me.txtDBPath.Text

        'Oligo
        frmNewMain.OligoEnabled = Me.chkOligoEnabled.Checked
        frmNewMain.OligoLabSuffix = Me.txtOligoLabSuffix.Text
        frmNewMain.OligoCustomField1 = Me.txtOligoCustomField1.Text
        frmNewMain.OligoCustomField2 = Me.txtOligoCustomField2.Text

        'Yeast
        frmNewMain.YeastEnabled = Me.chkYeastEnabled.Checked
        frmNewMain.YeastLabSuffix = Me.txtYeastLabSuffix.Text
        frmNewMain.YeastCustomField1 = Me.txtYeastCustomField1.Text
        frmNewMain.YeastCustomField2 = Me.txtYeastCustomField2.Text()

        'Bacteria
        frmNewMain.BacteriaEnabled = Me.chkBacteriaEnabled.Checked
        frmNewMain.BacteriaLabSuffix = Me.txtBacteriaLabSuffix.Text
        frmNewMain.BacteriaCustomField1 = Me.txtBacteriaCustomField1.Text
        frmNewMain.BacteriaCustomField2 = Me.txtBacteriaCustomField2.Text

        'Cell
        frmNewMain.CellLineEnabled = Me.chkCellLineEnabled.Checked
        frmNewMain.CellLineLabSuffix = Me.txtCellLineLabSuffix.Text
        frmNewMain.CellLineCustomField1 = Me.txtCellLineCustomField1.Text
        frmNewMain.CellLineCustomField2 = Me.txtCellLineCustomField2.Text


        'Saving to the INI
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "DBPath", Me.txtDBPath.Text)

        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "OligoEnabled", frmNewMain.OligoEnabled)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "OligoLabSuffix", frmNewMain.OligoLabSuffix)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "OligoCustomField1", frmNewMain.OligoCustomField1)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "OligoCustomField2", frmNewMain.OligoCustomField2)

        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "YeastEnabled", frmNewMain.YeastEnabled)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "YeastLabSuffix", frmNewMain.YeastLabSuffix)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "YeastCustomField1", frmNewMain.YeastCustomField1)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "YeastCustomField2", frmNewMain.YeastCustomField2)

        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "BacteriaEnabled", frmNewMain.BacteriaEnabled)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "BacteriaLabSuffix", frmNewMain.BacteriaLabSuffix)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "BacteriaCustomField1", frmNewMain.BacteriaCustomField1)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "BacteriaCustomField2", frmNewMain.BacteriaCustomField2)


        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "CellLineEnabled", frmNewMain.CellLineEnabled)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "CellLineLabSuffix", frmNewMain.CellLineLabSuffix)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "CellLineCustomField1", frmNewMain.CellLineCustomField1)
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "CellLineCustomField2", frmNewMain.CellLineCustomField2)


        '*************************************************
        'Handling the oligo formula stuff

        'determining if they change the formulas used with the dna strands. If they did we have to recaluculate stuff.
        'the one problem with all of this is i don't let the other clients know what the setting is so they might flip it to something
        'else.

        If CSng(Me.txtPerFormamide.Text) <> frmNewMain.OligoPerFormamide Or CSng(Me.txtMofNaCl.Text) <> frmNewMain.OligoMOfNaCl Then
            'need to update the database this could take awhile

            Me.Cursor = Cursors.WaitCursor

            For Each tOligo As Oligo In Oligo.DBOligos(frmNewMain.Conn)

                If tOligo.Sequnce <> "" Then
                    tOligo.Tm = DNA.GoodTm(tOligo.Sequnce, frmNewMain.OligoMOfNaCl, frmNewMain.OligoPerFormamide)
                    tOligo.DBSave(frmNewMain.Conn)
                End If

            Next

            Me.Cursor = Cursors.Default

        End If

        'savign to variables
        frmNewMain.OligoMOfNaCl = Me.txtMofNaCl.Text
        frmNewMain.OligoPerFormamide = Me.txtPerFormamide.Text

        'saving formulas to ini file
        INIAccess.INIWrite(GenDec.INIFileName, "frmMain", "OligoMOfNaCl", frmNewMain.OligoMOfNaCl)
        INIAccess.INIRead(GenDec.INIFileName, "frmMain", "OligoPerFormamide", frmNewMain.OligoPerFormamide)

        'returning
        Me.DialogResult = Windows.Forms.DialogResult.OK

        'informing the user to restart
        MessageBox.Show("You should restart LINA for ALL changes to take affect.", "Restart", MessageBoxButtons.OK, MessageBoxIcon.Information)


        Me.Close()


    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.Close()

    End Sub

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click

        'preparing the open file dialog for access databases
        Me.ofdFiler.Filter = "Databases (*.mdb)| *.mdb"
        Me.ofdFiler.InitialDirectory = Application.StartupPath 'a place to start looking

        If Me.ofdFiler.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then

            'Testing the connection
            If frmNewMain.ConnectToDB(Me.ofdFiler.FileName) = True Then
                'could connect to the database so 
                Me.txtDBPath.Text = Me.ofdFiler.FileName
            Else
                'invalid db try again. ConnectToDB will throw a msgbox
            End If


        Else
            'They didn't select a db from the dialog box. must have canceled it.

        End If

    End Sub


#End Region

#Region " Validation Support "

    ''' <summary>
    ''' Determines if all the settings are valid.
    ''' </summary>
    ''' <returns>True if all the user's settings are valid</returns>
    ''' <remarks></remarks>
    Private Function ValidateForm() As Boolean


        Dim Moles As Single

        'Checking database
        If Me.txtDBPath.Text = "" Then
            MessageBox.Show("Please select a Database", "", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Function
        End If


        If Single.TryParse(Me.txtMofNaCl.Text, Moles) = False Then
            MessageBox.Show("Please specify Valid Moles of NaCl", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtMofNaCl.Focus()
            Exit Function
        End If

        If Moles <= 0 Then
            MessageBox.Show("Moles of NaCl must be > than 0", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtMofNaCl.Focus()
            Exit Function
        End If

        If IsNumeric(Me.txtPerFormamide.Text) = False Then
            MessageBox.Show("Please specify Valid % Formamide", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtPerFormamide.Focus()
            Exit Function
        End If

        If CSng(Me.txtPerFormamide.Text) > 1 Or CSng(Me.txtPerFormamide.Text) < 0 Then
            MessageBox.Show("Please specify Valid % Formamide", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtPerFormamide.Focus()
            Exit Function
        End If


        Return True


    End Function

#End Region


End Class